# COPYRIGHT: (c) 1992@2000 by SP&AR&C HOLLAND by GNU Public Licence 
# FILE : makefile
# DESCRIPTION : in behalf of sorting program
# PROJECT : TFORTH
# AUTOR : A vd Horst
# LANGUAGE : make Turbo C++ (3.0)
# CREATED : 920906 AH
# LAST CHANGE : 950220 AH removed TSTEXPR.EXE
# LAST CHANGE : 950213 AH preparation for release
# LAST CHANGE : 950126 AH small adaptation to new system (ZIP)
# LAST CHANGE : 941205 AH formalized expression test
# LAST CHANGE : 941208 AH eliminated stable.out (running on MSDOS)
# LAST CHANGE : 941125 AH added test for -n option
# LAST CHANGE : 940320 AH CARETDOLLAR removed
# LAST CHANGE : 921215 AH cleanup for release
# LAST CHANGE : 921107 AH added MERGEP module
# LAST CHANGE : 921106 AH added ordertest and testall
# LAST CHANGE : 921105 AH added TSTORDER.BAT (order of options test)
# LAST CHANGE : 920920 AH added MBUFFER.H
# LAST CHANGE :
#
# WARNING! This makefile assumes TLINK.CFG is installed with the
#          TLINK.EXE file to link libraries from the lib directory
# WARNING! The making of ``save'' fail. Pipes will fail to work in
# Borland MAKE too

# Have TCC look at the includes
# WARNING : not compatible with other makes!
.AUTODEPEND

# Test C options : compact model, stack checking, debug, no inlining
#COPTS= +SSORT.CFG -N -v -vi- -DOPTIMIZE
#COPTS= +SSORT.CFG -N -v -vi- -DDEBUG -DOPTIMIZE
#COPTS= +SSORT.CFG -N -v -vi- -DDEBUG

# Production C options: compact model, optimize, nodebug and inline
COPTS= +SSORT.CFG -O -G -v- -DOPTIMIZE

ZIP=C:\BIN\ARC\PKZIP

.cpp.obj:
  tcc $(COPTS) -c $<

SRC1=ssort.cpp lib.cpp sstring.cpp search.cpp sbuffer.cpp scompare.cpp
SRC2=mergep.cpp ssortlib.cpp
OBJ1=ssort.obj lib.obj sstring.obj search.obj sbuffer.obj scompare.obj
OBJ2=mergep.obj ssortlib.obj
HDR1=lib.h sheap.h search.h sstring.h sbuffer.h config.h scompare.h
HDR2=mergep.h version.h read.h ssortlib.h
HDR=$(HDR1) $(HDR2)
TAB=ascicrea.cpp lexcrea.cpp
TXT= leesmij.txt readme.txt regexpr.txt ssort.txt test.txt
TSTTXT= test.txt report.txt
TST1= blanks.tst context.tst mult.tst rec.tst stable.tst straight.8 straight.r straight.s straight.tst tstexprb.tst
TST2= blanks.out context.out dos3d3.out mult.out rec.out tstexprb.out telephon.tst telephon.n

# Files belonging to release, but not for testing
REL= leesmij.txt readme.txt regexpr.txt ssort.exe ssort.txt test.zip
TSTEXE=tstmerge.exe tstexprb.exe ssortd.exe ascicrea.exe
TSTSRC=tstmerge.cpp tstexprb.cpp read.cpp tstmerge.prj
EXE=ssort.exe ssortd.exe ascicrea.exe lexcrea.exe
MODEL=c

ssort.exe : $(OBJ1) $(OBJ2)
   tlink C0$(MODEL) $(OBJ1) $(OBJ2), $@, ,C$(MODEL)

# Create cntrtab.h according to the current country set in CONFIG.SYS
# Pipes do not work: ascicrea | sort |lexcrea >cntrtab.h
# Comment the last line in if you actually want to use it in scompare.cpp
cntrtab.h : lexcrea.exe weight c:\config.sys
   sort < weight > temp
   lexcrea <temp > cntrtab.h
#  copy cntrtab.h lextab.h

ascicrea.exe : ascicrea.obj
   tlink C0$(MODEL) ascicrea.obj , $@, ,C$(MODEL)

lexcrea.exe : lexcrea.obj
   tlink C0$(MODEL) lexcrea.obj , $@, ,C$(MODEL)

# Note following handled mostly with .AUTODEPENDANT

# But not this! lextab.h is a target itself
# Comment this in of you have changed code in scompare.cpp
# to take into account an external table.
#scompare.obj: lextab.h

ascicrea.obj:
lexcrea.obj:
lib.obj:
read.obj:
mergep.obj:
sbuffer.obj:
search.obj:
ssort.obj:
ssortlib.obj:
sstring.obj:
tstmerge.obj:
tstexprb.obj:

############# interactive test programs ###################
TSTMOBJ = tstmerge.obj read.obj lib.obj mergep.obj

tstmerge.exe: tstmerge.prj tstmerge.obj read.obj lib.obj mergep.obj
   @echo recompile if you forgot the -DDEBUG in COPTS
   @echo use TSTMERGE.PRJ to link test program TSTMERGE.EXE

############# tstexprb.exe ###################
TSTEOBJ = tstexprb.obj lib.obj

# search.cpp is included as a source
tstexprb.obj: search.cpp search.h

tstexprb.exe: tstexprb.obj
   tlink C0$(MODEL) $(TSTEOBJ), $@, ,C$(MODEL)


############################################################
###############  MAINTENANCE ###############################
############################################################

# This does not work because the Borland make is broke
save :
#  echo mkdir $(SD) >monkey.bat
#  echo for %%i in ( $(HDR1) ) DO COPY %%i $(SD) >> monkey.bat
#  echo for %%i in ( $(HDR2) ) DO COPY %%i $(SD) >> monkey.bat
#  echo for %%i in ( $(SRC1) ) DO COPY %%i $(SD) >> monkey.bat
#  echo for %%i in ( $(SRC2) ) DO COPY %%i $(SD) >> monkey.bat
#  echo for %%i in ( $(TAB) ) DO COPY %%i $(SD) >> monkey.bat
#  echo COPY makefile $(SD) >> monkey.bat
#  echo COPY ssort.cfg $(SD) >> monkey.bat
#  monkey.bat
#  del monkey.bat

# Usage with the external define SD, e.g. make -DSD=A zip
zip :
   $(ZIP) $(SD) $(EXE) makefile
   $(ZIP) $(SD) $(TSTEXE) $(TXT) $(TSTTXT) todo.txt
   $(ZIP) $(SD) $(TST1)
   $(ZIP) $(SD) $(TST2)
   $(ZIP) $(SD) $(HDR1) $(HDR2)
   $(ZIP) $(SD) $(SRC1) $(SRC2)
   $(ZIP) $(SD) $(TSTSRC) ssort.cfg ssort.prj
   $(ZIP) $(SD) $(TAB)

# Usage with the external define SD, e.g. make -DSD=A zip
release :
   del test.zip
   del SSORT$(SD).zip
   $(ZIP) test $(TSTEXE) $(TSTTXT) makefile
   $(ZIP) test $(TST1)
   $(ZIP) test $(TST2)
   $(ZIP) test -D $(REL)
   $(ZIP) SSORT$(SD) $(REL)

# Usage with the external define SD, e.g. make -DSD=A zip
srcrelease : release
   $(ZIP) SSORT$(SD) $(HDR1) $(HDR2)
   $(ZIP) SSORT$(SD) $(SRC1) $(SRC2)
   $(ZIP) SSORT$(SD) $(TSTSRC) ssort.cfg ssort.prj
   $(ZIP) SSORT$(SD) $(TAB)

print :
   print $(HDR1) $(HDR2) $(SRC1) $(SRC2)

clean :
   del *.obj
   del *.exe
   del *.sym

############################################################
###############  TESTING   #################################
############################################################

weight : ascicrea.exe
    ascicrea > weight

# Do ALL the tests present in the makefile
testall : test redirtest reversetest lexicotest numtest ordertest multest septest exprtest rectest context offsettest

# a simple straight test
test : ssort.exe
   ssort straight.tst temp
   diff temp straight.s
   crc temp straight.s

# test redirection
redirtest : ssort.exe
   ssort straight.tst>temp
   diff temp straight.s
   crc temp straight.s
   ssort <straight.tst>temp
   diff temp straight.s
   crc temp straight.s

# test reverse sorting
reversetest : ssort.exe
   ssort -r straight.tst temp
   diff temp straight.r
   crc temp straight.r
# test reverse sorting with explicit -s
   ssort -s -r straight.tst temp
   diff temp straight.r
   crc temp straight.r

# Test all combinations of lexicographic ordering
# Comparisons are made against SORT
# Start with a test of SORT itself, to prevent false conclusions
# Also test stability
lexicotest : ssort.exe weight
   sort < straight.tst> temp2
   diff temp2 dos3d3.out
   crc temp2 dos3d3.out
   ssort -c \0A -l straight.tst temp1
   sort < straight.tst> temp2
   diff temp1 temp2
   crc temp1 temp2
   ssort -c \0A -r -l straight.tst temp1
   sort /r < straight.tst> temp2
   diff temp1 temp2
   crc temp1 temp2
   ssort -c \0A -l -r straight.tst temp1
   sort /r < straight.tst> temp2
   diff temp1 temp2
   crc temp1 temp2
   ssort -c \0A -l weight temp1
   sort <weight > temp2
   diff temp1 temp2
   crc temp1 temp2
   ssort -c \0A -l -r weight temp1
   sort /r <weight > temp2
   diff temp1 temp2
   crc temp1 temp2
   ascicrea > temp1
   ssort -c \0A weight temp2
   diff temp1 temp2
   crc temp1 temp2
   ssort -l stable.tst temp1
   sort < stable.tst >temp2
   diff temp1 temp2
   crc temp1 temp2

offsettest :
   ssort -E $\n$ -O8 -l straight.tst temp1
   sort /+8 < straight.tst> temp2
   diff temp1 temp2
   crc temp1 temp2
   ssort -E $\n$ -r -O8 -l straight.tst temp1
   sort /r /+8 < straight.tst> temp2
   diff temp1 temp2
   crc temp1 temp2

# Test -N option
numtest : ssort.exe
   ssort -n telephon.tst temp
   diff temp telephon.n
   crc temp telephon.n

# Test whether the deciphering of
# options has errors with respect to ordering
#  (no order dependancy)
# File to compare against is generated by sort
ordertest : ssort.exe
   sort /r /+8 < straight.tst> temp2
   diff straight.8 temp2
   crc straight.8 temp2
   ssort -E $\n$ -r -O8 -l straight.tst temp
   diff temp temp2
   crc temp temp2
   ssort -E $\n$ -r -l -O8 straight.tst temp
   diff temp temp2
   crc temp temp2
   ssort -E $\n$ -O8 -r -l straight.tst temp
   diff temp temp2
   crc temp temp2
   ssort -E $\n$  -l -O8 -r straight.tst temp
   diff temp temp2
   crc temp temp2
   ssort -E $\n$ -l -r -O8 straight.tst temp
   diff temp temp2
   crc temp temp2

# Test of multiple sort
multest : ssort.exe
   ssort -E ^@\n@\n -M 0S1S mult.tst >temp
   ssort -E ^@\n@\n@\n -M 0S1S2S mult.tst >>temp
   diff temp mult.out
   crc temp mult.out

# Test of record splitting at buffer boundary
septest : ssort.exe
   ssort -B -E ^...\20* blanks.tst temp
   diff blanks.out temp
   crc blanks.out temp

# Test of different ways to specify the same record
rectest : ssort.exe
   ssort rec.tst temp2
   ssort -F 3 rec.tst temp3
   ssort -B -E ^...$ rec.tst temp4
   ssort -E ^..$ rec.tst temp5
   ssort -B -E ^.$\0D\0A$ -M 0S rec.tst temp6
   ssort -F 1:1:1 -M 0S rec.tst temp7
   diff rec.out temp2
   diff rec.out temp3
   diff rec.out temp4
   diff rec.out temp5
   diff rec.out temp6
   diff rec.out temp7
   crc rec.out temp2 temp3 temp4 temp5 temp6 temp7

# Test of context
context : tstexprb.exe
   ssort -E $\n$Record: context.tst temp
   diff temp context.out
   crc temp context.out

# Test of interpretation of -E separator
exprtest : tstexprb.exe
   tstexprb < tstexprb.tst > temp
   diff temp tstexprb.out
   crc temp tstexprb.out

#################################################################
################### Time consuming tests ########################
#################################################################

# Test merging
# Test stability of merge fase for -L option
# You should see a nice striping pattern
time1 :
    copy stable.tst+stable.tst+stable.tst+stable.tst s3
    copy s3+s3+s3+s3+s3+s3+s3+s3 s6
    del s3
    copy s6+s6+s6+s6+s6+s6+s6+s6 s9
    del s6
    ssort -l s9
    del s9

# Test the extreme case of record size 4 with four 1 char fields,
# on a file that demands a merging phase.
# It is essential that rec.tst does not containt ASCII NULL chars.
# Run this test outside of Borland make, by copying it into a batch file.
# [ Borland replaces "$." by "time2" and allows no escape from this. ]
# Note: there is a repetitive pattern of 3 in the input.
# The regular pattern allows to check the output manually, which you
# should do before regarding the test succesful.
time2 :
   copy rec.tst+rec.tst+rec.tst+rec.tst recl.tst /b
   ssort -B -E ^.$.$.$.$ -M 0S3S1R2R recl.tst temp1
   ssort -F 1:1:1:1 -M 0S3S1R2R recl.tst temp2
   diff temp1 temp2
   crc temp1 temp2
